# -*- coding: utf-8 -*-

from warriors.warrior import Warrior

#https://github.com/SpiderLabs/ikeforce
#symlink
#You can test this against conceal.htb (10.10.10.116)

class Ike_warrior (Warrior):
    def __init__(self, host, port, workdir, proto, ebrute, username, ulist, password, plist, notuse, protohelp, interactive, verbose):
        port = port if port != "0" else "500"
        Warrior.__init__(self, host, port, workdir, proto, ebrute, username, ulist, password, plist, notuse, protohelp, interactive, verbose)
        self.password = self.password if len(self.password)>0 else "vpn"

        self.cmds = [
            {"name": "nmap_ike", "cmd": 'nmap -sV --script *ike* -sU -p ' + self.port + ' ' + self.host, "shell": False, "chain": False},
            {"name": "ike-scan", "cmd": 'ike-scan -M --sport '+self.port+' --dport '+self.port+' '+ self.host, "shell": False, "chain": True},
            {"name": "ike-scan_nat", "cmd": 'ike-scan -M --nat-t ' + self.host, "shell": False, "chain": True},
            {"name": "ike-scan_showback", "cmd": 'ike-scan -M --showbackoff --sport '+self.port+' --dport '+self.port+' ' + self.host,
             "shell": False, "chain": True},
            {"name": "ike-scan_agressive",
             "cmd": 'ike-scan --aggressive --id=' + self.password + ' --sport '+self.port+' --dport '+self.port+' '+self.host,
             "shell": False, "chain": True},
            {"name": "ike-scan_agr_psk",
             "cmd": 'ike-scan --pskcrack --aggressive --id='+self.password+' --sport '+self.port+' --dport '+self.port+' '+ self.host,
             "shell": False, "chain": True},

        ]

        if self.ebrute or self.protohelp:
            if self.ip != "":
                self.plist = self.plist if self.plist != "" else self.wordlists_path+'/wordlists/groupnames.txt'
                self.cmds.append({"name": "ikeforce_id", "cmd": 'ikeforce '+self.ip+' -e -w '+self.plist+' -s 2', "shell": False, "chain": True})
            #TODO: Bruteforce XAUTH and transformations (the 500 port is needed so the bruteforce has to be concatenated)

        if self.protohelp:
            self.print_help()